#include "app_net.h"
#include "CH57x_common.h"
#include "stdint.h"
#include "CH57xBLE_LIB.H"
#include "CH57xNET.h"

#include "app_drv_fifo.h"
#include "net_config.h"


extern void app_ble_start_to_send(void);


/* ʾغ */
#define RECE_BUF_LEN                          536    





uint8_t app_net_task_id = 0xff;
extern bool uart_rx_flag; 
//extern  app_drv_fifo_t app_uart_rx_fifo;
extern  app_drv_fifo_t app_tcp_to_ble_fifo;



#define KEEPLIVE_ENABLE                      1                                  /* KEEPLIVE */

/* ĻȫֱҪ壬е */
__align(16)UINT8    CH57xMACRxDesBuf[(RX_QUEUE_ENTRIES )*16];                   /* MAC16ֽڶ */
__align(4) UINT8    CH57xMACRxBuf[RX_QUEUE_ENTRIES*RX_BUF_SIZE];                /* MACջ4ֽڶ */
__align(4) SOCK_INF SocketInf[CH57xNET_MAX_SOCKET_NUM];                         /* SocketϢ4ֽڶ */

UINT16 MemNum[8] = {CH57xNET_NUM_IPRAW,
                    CH57xNET_NUM_UDP,
                    CH57xNET_NUM_TCP,
                    CH57xNET_NUM_TCP_LISTEN,
                    CH57xNET_NUM_TCP_SEG,
                    CH57xNET_NUM_IP_REASSDATA,
                    CH57xNET_NUM_PBUF,
                    CH57xNET_NUM_POOL_BUF
                    };
UINT16 MemSize[8] = {CH57xNET_MEM_ALIGN_SIZE(CH57xNET_SIZE_IPRAW_PCB),
                    CH57xNET_MEM_ALIGN_SIZE(CH57xNET_SIZE_UDP_PCB),
                    CH57xNET_MEM_ALIGN_SIZE(CH57xNET_SIZE_TCP_PCB),
                    CH57xNET_MEM_ALIGN_SIZE(CH57xNET_SIZE_TCP_PCB_LISTEN),
                    CH57xNET_MEM_ALIGN_SIZE(CH57xNET_SIZE_TCP_SEG),
                    CH57xNET_MEM_ALIGN_SIZE(CH57xNET_SIZE_IP_REASSDATA),
                    CH57xNET_MEM_ALIGN_SIZE(CH57xNET_SIZE_PBUF) + CH57xNET_MEM_ALIGN_SIZE(0),
                    CH57xNET_MEM_ALIGN_SIZE(CH57xNET_SIZE_PBUF) + CH57xNET_MEM_ALIGN_SIZE(CH57xNET_SIZE_POOL_BUF)
                    };
__align(4)UINT8 Memp_Memory[CH57xNET_MEMP_SIZE];
__align(4)UINT8 Mem_Heap_Memory[CH57xNET_RAM_HEAP_SIZE];
__align(4)UINT8 Mem_ArpTable[CH57xNET_RAM_ARP_TABLE_SIZE];
/******************************************************************************/
/* ʾغ */
#define RECE_BUF_LEN                          536                               /* ջĴС */
/* CH57xNETTCPMSSΪ536ֽڣһTCPݲΪ536ֽ */
/* TCPЭջûڽأֵΪsocketĽջȡ趨 */
/* RX_QUEUE_ENTRIESʱҪMSSʹ֮Ĺϵ細ֵΪ4*MSSԶһλᷢ */
/* 4TCPRX_QUEUE_ENTRIESС4ȻᵼݰʧӶͨѶЧʽ */
/* RX_QUEUE_ENTRIESҪ( /MSS ),socketͬʱдݣ */ 
/* RX_QUEUE_ENTRIESҪ(( /MSS )*socket) ڶsocketͬʱдշʱ */
/* Ϊ˽ԼRAM뽫ջĳΪMSS */

/* CH579ض */
                    
UINT8 MACAddr[6] ={0x84,0xc2,0xe4,0x02,0x03,0x04};                              /* CH579MACַ */
UINT8 IPAddr[4] = {192,168,11,221};                                              /* CH579IPַ */
UINT8 GWIPAddr[4]={192,168,11,254};                                                /* CH579 */
UINT8 IPMask[4] = {255,255,255,0};                                              /* CH579 */
UINT8 DESIP[4] =  {192,168,11,121};                                              /* ĿIPַ */

uint16_t dst_port = 50287;
uint16_t src_port_start = 20000;
UINT8 SocketId=0;;                                                                 /* socketԲö */
UINT8 SocketRecvBuf[RECE_BUF_LEN];                                              /* socketջ */
UINT8 MyBuf[RECE_BUF_LEN];                                                      /* һʱ */


/* ڵƶ PBڵʮλЧ */
UINT16 CH57xNET_LEDCONN=0x0010;                                                 /* ָʾ PB4 */
UINT16 CH57xNET_LEDDATA=0x0080;                                                 /* ͨѶָʾ PB7 */ 





/*******************************************************************************
* Function Name  : mStopIfError
* Description    : ʹãʾ
* Input          : iError 
* Output         : None
* Return         : None
*******************************************************************************/
void mStopIfError(UINT8 iError)
{
    if (iError == CH57xNET_ERR_SUCCESS) return;                                 /* ɹ */
    PRINT("mStopIfError: %02X\r\n", (UINT16)iError);                            /* ʾ */   
}

/*******************************************************************************
* Function Name  : CH57xNET_CreatTcpSocket
* Description    : TCP Client socket
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH57xNET_CreatTcpSocket(void)
{
   UINT8 i;                                                             
   SOCK_INF TmpSocketInf;                                                       /* ʱsocket */
   memset((void *)&TmpSocketInf,0,sizeof(SOCK_INF));                            /* ڲὫ˱ƣýʱȫ */
   memcpy((void *)TmpSocketInf.IPAddr,DESIP,4);                                 /* ĿIPַ */
   TmpSocketInf.DesPort = dst_port; 
   if(src_port_start>50000){
        src_port_start = 20000;
   }
   TmpSocketInf.SourPort = src_port_start++;                                                /* Դ˿ */
   TmpSocketInf.ProtoType = PROTO_TYPE_TCP;                                     /* socekt */
   TmpSocketInf.RecvStartPoint = (UINT32)SocketRecvBuf;                         /* ýջĽջ */
   TmpSocketInf.RecvBufLen = RECE_BUF_LEN ;                                     /* ýջĽճ */
   i = CH57xNET_SocketCreat(&SocketId,&TmpSocketInf);                           /* socketصsocketSocketId */
   mStopIfError(i);                                                             /*  */
#ifdef  KEEPLIVE_ENABLE
   CH57xNET_SocketSetKeepLive( SocketId, 1 );                                   /* socketKEEPLIVEܣV06汾֧֣ */
#endif

   i = CH57xNET_SocketConnect(SocketId);                                        /* TCP */
   mStopIfError(i);                                                             /*  */
   i = CH57xNET_SetSocketTTL( SocketId,10 );
   mStopIfError(i);                                                             /*  */
}


/*******************************************************************************
* Function Name  : net_initkeeplive
* Description    : keepliveʼ
* Input          : None      
* Output         : None
* Return         : None
*******************************************************************************/
#ifdef  KEEPLIVE_ENABLE
void net_initkeeplive(void)
{
    struct _KEEP_CFG  klcfg;

    klcfg.KLIdle = 20000;                                                       /*  */
    klcfg.KLIntvl = 10000;                                                      /*  */
    klcfg.KLCount = 5;                                                          /*  */
    CH57xNET_ConfigKeepLive(&klcfg);
}
#endif

/*******************************************************************************
* Function Name  : CH57xNET_LibInit
* Description    : ʼ
* Input          : ip      ipַָ
*                gwip    ipַָ
*                : mask    ָ
*                : macaddr MACַָ 
* Output         : None
* Return         : ִ״̬
*******************************************************************************/
UINT8 CH57xNET_LibInit(/*const*/ UINT8 *ip,/*const*/ UINT8 *gwip,/*const*/ UINT8 *mask,/*const*/ UINT8 *macaddr)
{
    UINT8 i;
    struct _CH57x_CFG cfg;

    if(CH57xNET_GetVer() != CH57xNET_LIB_VER)return 0xfc;                       /* ȡİ汾ţǷͷļһ */
    CH57xNETConfig = LIB_CFG_VALUE;                                             /* Ϣݸñ */
    cfg.RxBufSize = RX_BUF_SIZE; 
    cfg.TCPMss   = CH57xNET_TCP_MSS;
    cfg.HeapSize = CH57x_MEM_HEAP_SIZE;
    cfg.ARPTableNum = CH57xNET_NUM_ARP_TABLE;
    cfg.MiscConfig0 = CH57xNET_MISC_CONFIG0;
    CH57xNET_ConfigLIB(&cfg);
    i = CH57xNET_Init(ip,gwip,mask,macaddr);
#ifdef  KEEPLIVE_ENABLE
    net_initkeeplive( );
#endif
    return (i);                      
}




/*******************************************************************************
* Function Name  : CH57xNET_HandleSockInt
* Description    : Socketжϴ
* Input          : sockeid  socket
*                initstat ж״̬
* Output         : None
* Return         : None
*******************************************************************************/
void CH57xNET_HandleSockInt(UINT8 sockeid,UINT8 initstat)
{
    UINT32 len;
    //UINT32 totallen;
    //UINT8 *p = MyBuf;

    if(initstat & SINT_STAT_RECV)                                               /* ж */
    {
        len = CH57xNET_SocketRecvLen(sockeid,NULL);                             /* ѯ */
		PRINT("Receive Len = %d\r\n",len);                           
        //totallen = len;
        CH57xNET_SocketRecv(sockeid,MyBuf,&len);                                /* ջݶMyBuf*/
        for(uint32_t i = 0;i<len;i++){
            PRINT("%02x ",MyBuf[i]);
        }
        PRINT("\r\n");
        uint8_t error;
     
        uint16_t len_to_write_to_fifo = len;
        error = app_drv_fifo_write(&app_tcp_to_ble_fifo,MyBuf,&len_to_write_to_fifo);
        if(error != 0){
            PRINT("fifo write error \r\n");
        }
        PRINT("write len %d\r\n",len_to_write_to_fifo);
        
        app_ble_start_to_send();
    }
    if(initstat & SINT_STAT_CONNECT)                                            /* TCPж */
    {                                                                           /* жϱʾTCPѾӣԽշ */
        PRINT("TCP Connect Success\n");                           
    }
    if(initstat & SINT_STAT_DISCONNECT)                                         /* TCPϿж */
    {                                                                           /* жϣCH579ڲὫsocketΪر*/
        PRINT("TCP Disconnect\n");                                              /* Ӧ´ */
        tmos_start_task(app_net_task_id,APP_NET_TCP_RESTART,1600);

    }
    if(initstat & SINT_STAT_TIM_OUT)                                            /* TCPʱж */
    {                                                                           /* жϣCH579ڲὫsocketΪر*/
        PRINT("TCP Timout\n");                                                  /* Ӧ´ */
        tmos_start_task(app_net_task_id,APP_NET_TCP_RESTART,1600);

    }
}


/*******************************************************************************
* Function Name  : CH57xNET_HandleGloableInt
* Description    : ȫжϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH57xNET_HandleGlobalInt(void)
{
    UINT8 initstat;
    UINT8 i;
    UINT8 socketinit;
    initstat = CH57xNET_GetGlobalInt();                                         /* ȫж״̬ */
	  PRINT("initstat=%x  \r\n",initstat);
	
    if(initstat & GINT_STAT_UNREACH)                                            /* ɴж */
    {
        PRINT("UnreachCode %d\n",CH57xInf.UnreachCode);                       /* 鿴ɴ */
        PRINT("UnreachProto %d\n",CH57xInf.UnreachProto);                     /* 鿴ɴЭ */
        PRINT("UnreachPort %d\n",CH57xInf.UnreachPort);                       /* ѯɴ˿ */       
    }
   if(initstat & GINT_STAT_IP_CONFLI)                                           /* IPͻж */
   {
		PRINT("IP_CONFIL\r\n");
   }
   if(initstat & GINT_STAT_PHY_CHANGE)                                          /* PHYıж */
   {
       
       i = CH57xNET_GetPHYStatus();                                             /* ȡPHY״̬ */
       PRINT("GINT_STAT_PHY_CHANGE %02x\n",i);
        if(i>1){
            //CH57xNET_SocketClose(SocketId,TCP_CLOSE_ABANDON);
            //tmos_start_task(app_net_task_id,APP_NET_TCP_RESTART,1600);
        }else{
            CH57xNET_SocketClose(SocketId,TCP_CLOSE_ABANDON);
            PRINT("close SocketId=%d\r\n",SocketId);
        }
   }
   if(initstat & GINT_STAT_SOCKET)                                              /* Socketж */
   {
       for(i = 0; i < CH57xNET_MAX_SOCKET_NUM; i ++)                     
       {
           socketinit = CH57xNET_GetSocketInt(i);                               /* socketжϲ */
           if(socketinit)CH57xNET_HandleSockInt(i,socketinit);                  /* ж */
       }    
   }
}




static void app_net_ProcessOSALMsg( tmos_event_hdr_t *pMsg )
{
  switch ( pMsg->event )
  {
    case GATT_MSG_EVENT:
      break;
		
		default:
			break;
  }
}



uint16 app_net_process_event( uint8 task_id, uint16 events )
{
  
//  VOID task_id; // OSAL required parameter that isn't used in this function
  
  if ( events & SYS_EVENT_MSG )
  {
    uint8 *pMsg;
    if ( (pMsg = tmos_msg_receive( app_net_task_id )) != NULL )
    {
      app_net_ProcessOSALMsg( (tmos_event_hdr_t *)pMsg );
      // Release the OSAL message
      tmos_msg_deallocate( pMsg );
    }
    // return unprocessed events
    return (events ^ SYS_EVENT_MSG);
  }
  if ( events & APP_NET_START_EVT ){   
    PRINT("APP NET START_EVT\r\n");
    tmos_start_reload_task( app_net_task_id, APP_NET_TIMES_10_MS,16 );
    tmos_start_reload_task( app_net_task_id, APP_NET_TIMES_TICK,4 );
      
    tmos_start_task(app_net_task_id,APP_NET_TCP_RESTART,1600);
    //tmos_start_reload_task( app_net_task_id, APP_NET_TIMES_TEST,1600);
    return ( events ^ APP_NET_START_EVT );
  }
  if( events & APP_NET_TIMES_10_MS){
    //PRINT("12\r\n");
    CH57xNET_TimeIsr(CH57xNETTIMEPERIOD);                                              /* ʱжϷ */
    //R8_TMR0_INT_FLAG |= 0xff;						                                   /* ʱжϱ־ */
    return ( events ^ APP_NET_TIMES_10_MS );
  }
  if(events & APP_NET_TIMES_TICK){
        CH57xNET_MainTask();                                                    /* CH57xNETҪѭвϵ */
        if(CH57xNET_QueryGlobalInt())CH57xNET_HandleGlobalInt();                /* ѯжϣжϣȫжϴ */
      return ( events ^ APP_NET_TIMES_TICK );
  }
  if( events & APP_NET_TCP_RESTART){
  
    PRINT("CH57xNET_CreatTcpSocket\r\n");
    PRINT("socket id %d\r\n",SocketId);
    //if(SocketId)
    CH57xNET_CreatTcpSocket();  
    return (events ^ APP_NET_TCP_RESTART);
  }
      
  if(events & APP_NET_TIMES_TEST){
      
      uint32_t len = 10;
      uint8_t p[]={0,1,2,3,4,5,6,7,8,9};
      
      //CH57xNET_SocketSend(0,p,&len); 
      app_socket_send(p,len);
      return (events ^ APP_NET_TIMES_TEST);
  }
  // Discard unknown events
  return 0;
}


uint8_t app_socket_send(uint8_t *raw_data,uint32_t length)
{
   if(0 == length){
        return 0xff;
   }
   uint32_t len= length;
   CH57xNET_SocketSend(SocketId,raw_data,&len); 
   PRINT("SOCKET_SEND LENTH %d\r\n",len);
   if(0 == len){
        return 0xff;
   }
   return 0;
    
}
void app_net_init(void){
    //when use ethernet must enable PLL at first
    PWR_UnitModCfg(ENABLE, UNIT_SYS_PLL);
    
    app_net_task_id = TMOS_ProcessEventRegister(app_net_process_event);
    
   
        
    net_config_t net_config_data;    
    if(net_config_read(&net_config_data,NET_CONFIG_ADDR)){
        
        PRINT("net_config_read vaild\r\n");
//        UINT8 MACAddr[6] ={0x84,0xc2,0xe4,0x02,0x03,0x04};                              /* CH579MACַ */
//        UINT8 IPAddr[4] = {192,168,11,221};                                              /* CH579IPַ */
//        UINT8 GWIPAddr[4]={192,168,11,254};                                                /* CH579 */
//        UINT8 IPMask[4] = {255,255,255,0};                                              /* CH579 */
//        UINT8 DESIP[4] =  {192,168,11,121};                                              /* ĿIPַ */

//        uint16_t dst_port = 50287;
//        uint16_t src_port_start = 20000;
          memcpy(IPAddr,net_config_data.local_ip_address,4);
          memcpy(GWIPAddr,net_config_data.local_gateway,4);
          memcpy(DESIP,net_config_data.target_ip_adddress,4);
          //memcpy();
          dst_port = net_config_data.target_port;
          
          uint8_t net_mask[4]={0};
           PRINT("net_config_data.local_ip_mask = %d\r\n",net_config_data.local_ip_mask);
          if(net_config_transfer_mask_from_num_to_ip(net_config_data.local_ip_mask,net_mask)){
            memcpy(IPMask,net_mask,4);
            PRINT("IPMask=%d.%d.%d.%d\r\n",IPMask[0],IPMask[1],IPMask[2],IPMask[3]);  
          }

          
          
    }
    
    
    UINT32 i = 0;
    i = CH57xNET_LibInit(IPAddr,GWIPAddr,IPMask,MACAddr); 
    mStopIfError(i);
    PRINT("CH57xNETLibInit Success\r\n");
	
	NVIC_EnableIRQ(ETH_IRQn);
    tmos_set_event( app_net_task_id, APP_NET_START_EVT );
    
    //CH57xNET_CreatTcpSocket();                                                  /* TCP Socket */
    PRINT("CH579 TCP client\r\n");  	
}

/*******************************************************************************
* Function Name  : IRQ_Handler
* Description    : IRQжϷ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void ETH_IRQHandler( void )							                                   /* ̫ж */
{
	CH57xNET_ETHIsr();							                                       /* ̫жжϷ */
}

