



#include "stdint.h"
#include "stdbool.h"

#ifndef _NET_CONFIG_H
#define _NET_CONFIG_H






#pragma pack(1)
typedef struct {
    uint8_t local_ip_address[4];
    uint8_t local_ip_mask;
    uint8_t local_gateway[4];
    uint8_t target_ip_adddress[4];
    uint16_t target_port;
    uint8_t verify;
}net_config_t; 
#pragma pack()



void net_config_dump(net_config_t *p_config);

bool net_config_vaild(net_config_t *p_config);

bool net_config_save(net_config_t *p_config,uint32_t addr);

bool net_config_read(net_config_t *p_config,uint32_t addr);



#endif



